/* fuzzy_matching.c generated by valac 0.56.17, the Vala compiler
 * generated from fuzzy_matching.vala, do not modify */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

VALA_EXTERN gint util_search_distance (const gchar* item,
                           const gchar* query);
VALA_EXTERN gint util_damerau_levenshtein_distance (const gchar* source,
                                        const gchar* target,
                                        gint insert_cost,
                                        gint delete_cost,
                                        gint replace_cost,
                                        gint swap_cost);
static gint* _int_dup (gint* self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

gint
util_search_distance (const gchar* item,
                      const gchar* query)
{
	gchar** words = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint words_length1;
	gint _words_size_;
	gchar** query_words = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint query_words_length1;
	gint _query_words_size_;
	gint base_distance = 0;
	gint min_word = 0;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gint result;
	g_return_val_if_fail (item != NULL, 0);
	g_return_val_if_fail (query != NULL, 0);
	_tmp1_ = _tmp0_ = g_strsplit_set (item, " _-", 0);
	words = _tmp1_;
	words_length1 = _vala_array_length (_tmp0_);
	_words_size_ = words_length1;
	_tmp3_ = _tmp2_ = g_strsplit_set (query, " _-", 0);
	query_words = _tmp3_;
	query_words_length1 = _vala_array_length (_tmp2_);
	_query_words_size_ = query_words_length1;
	base_distance = 0;
	min_word = G_MAXINT;
	_tmp4_ = words;
	_tmp4__length1 = words_length1;
	{
		gchar** i_collection = NULL;
		gint i_collection_length1 = 0;
		gint _i_collection_size_ = 0;
		gint i_it = 0;
		i_collection = _tmp4_;
		i_collection_length1 = _tmp4__length1;
		for (i_it = 0; i_it < i_collection_length1; i_it = i_it + 1) {
			gchar* _tmp5_;
			gchar* i = NULL;
			_tmp5_ = g_strdup (i_collection[i_it]);
			i = _tmp5_;
			{
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint min = 0;
				gchar** _tmp9_;
				gint _tmp9__length1;
				_tmp6_ = i;
				_tmp7_ = strlen (_tmp6_);
				_tmp8_ = _tmp7_;
				if (_tmp8_ == 0) {
					_g_free0 (i);
					continue;
				}
				min = G_MAXINT;
				_tmp9_ = query_words;
				_tmp9__length1 = query_words_length1;
				{
					gchar** q_collection = NULL;
					gint q_collection_length1 = 0;
					gint _q_collection_size_ = 0;
					gint q_it = 0;
					q_collection = _tmp9_;
					q_collection_length1 = _tmp9__length1;
					for (q_it = 0; q_it < q_collection_length1; q_it = q_it + 1) {
						gchar* _tmp10_;
						gchar* q = NULL;
						_tmp10_ = g_strdup (q_collection[q_it]);
						q = _tmp10_;
						{
							const gchar* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							const gchar* _tmp14_;
							const gchar* _tmp15_;
							_tmp11_ = q;
							_tmp12_ = strlen (_tmp11_);
							_tmp13_ = _tmp12_;
							if (_tmp13_ == 0) {
								_g_free0 (q);
								continue;
							}
							_tmp14_ = i;
							_tmp15_ = q;
							min = MIN (min, util_damerau_levenshtein_distance (_tmp14_, _tmp15_, 5, 3, 2, 1));
							_g_free0 (q);
						}
					}
				}
				base_distance += min;
				min_word = MIN (min_word, min);
				_g_free0 (i);
			}
		}
	}
	_tmp16_ = words;
	_tmp16__length1 = words_length1;
	result = ((base_distance + min_word) / _tmp16__length1) / 2;
	query_words = (_vala_array_free (query_words, query_words_length1, (GDestroyNotify) g_free), NULL);
	words = (_vala_array_free (words, words_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

/**
 * This implementation is an adaptation based on Kevin L. Stern's work
 * https://github.com/KevinStern/software-and-algorithms
 *
 * The running time of the Damerau-Levenshtein algorithm is O(n*m) where n is
 * the length of the source string and m is the length of the target string.
 * This implementation consumes O(n*m) space.
 */
static gint*
_int_dup (gint* self)
{
	gint* dup;
	dup = g_new0 (gint, 1);
	memcpy (dup, self, sizeof (gint));
	return dup;
}

static gpointer
__int_dup0 (gpointer self)
{
	return self ? _int_dup (self) : NULL;
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}

gint
util_damerau_levenshtein_distance (const gchar* source,
                                   const gchar* target,
                                   gint insert_cost,
                                   gint delete_cost,
                                   gint replace_cost,
                                   gint swap_cost)
{
	gint delete_distance = 0;
	gint insert_distance = 0;
	gint match_distance = 0;
	gint jSwap = 0;
	gint maxSourceLetterMatchIndex = 0;
	gint* candidateSwapIndex = NULL;
	gint _tmp0_;
	gint* _tmp1_;
	gint swap_distance = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp6_;
	gint _tmp7_;
	gint* table = NULL;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint* _tmp14_;
	gint table_length1;
	gint table_length2;
	GeeHashMap* sourceIndexByCharacter = NULL;
	GeeHashMap* _tmp15_;
	GeeHashMap* _tmp17_;
	gint* _tmp61_;
	gint _tmp61__length1;
	gint _tmp61__length2;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	gint result;
	g_return_val_if_fail (source != NULL, 0);
	g_return_val_if_fail (target != NULL, 0);
	delete_distance = 0;
	insert_distance = 0;
	match_distance = 0;
	jSwap = 0;
	maxSourceLetterMatchIndex = 0;
	_tmp0_ = 0;
	_tmp1_ = __int_dup0 (&_tmp0_);
	candidateSwapIndex = _tmp1_;
	swap_distance = 0;
	_tmp2_ = strlen (source);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == 0) {
		gint _tmp4_;
		gint _tmp5_;
		_tmp4_ = strlen (target);
		_tmp5_ = _tmp4_;
		result = _tmp5_ * insert_cost;
		_g_free0 (candidateSwapIndex);
		return result;
	}
	_tmp6_ = strlen (target);
	_tmp7_ = _tmp6_;
	if (_tmp7_ == 0) {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = strlen (source);
		_tmp9_ = _tmp8_;
		result = _tmp9_ * delete_cost;
		_g_free0 (candidateSwapIndex);
		return result;
	}
	_tmp10_ = strlen (source);
	_tmp11_ = _tmp10_;
	_tmp12_ = strlen (target);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_new0 (gint, _tmp11_ * _tmp13_);
	table = _tmp14_;
	table_length1 = _tmp11_;
	table_length2 = _tmp13_;
	_tmp15_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	sourceIndexByCharacter = _tmp15_;
	if (string_get_char (source, (glong) 0) != string_get_char (target, (glong) 0)) {
		gint* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		_tmp16_ = table;
		_tmp16__length1 = table_length1;
		_tmp16__length2 = table_length2;
		_tmp16_[(0 * _tmp16__length2) + 0] = MIN (replace_cost, delete_cost + insert_cost);
	}
	_tmp17_ = sourceIndexByCharacter;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, (gpointer) ((gintptr) string_get_char (source, (glong) 0)), (gpointer) ((gintptr) 0));
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				gint _tmp20_;
				gint _tmp21_;
				gint* _tmp22_;
				gint _tmp22__length1;
				gint _tmp22__length2;
				gint _tmp23_;
				gint _tmp24_ = 0;
				gint* _tmp25_;
				gint _tmp25__length1;
				gint _tmp25__length2;
				if (!_tmp18_) {
					gint _tmp19_;
					_tmp19_ = i;
					i = _tmp19_ + 1;
				}
				_tmp18_ = FALSE;
				_tmp20_ = strlen (source);
				_tmp21_ = _tmp20_;
				if (!(i < _tmp21_)) {
					break;
				}
				_tmp22_ = table;
				_tmp22__length1 = table_length1;
				_tmp22__length2 = table_length2;
				_tmp23_ = _tmp22_[((i - 1) * _tmp22__length2) + 0];
				delete_distance = _tmp23_ + delete_cost;
				insert_distance = ((i + 1) * delete_cost) + insert_cost;
				if (string_get_char (source, (glong) i) == string_get_char (target, (glong) 0)) {
					_tmp24_ = 0;
				} else {
					_tmp24_ = replace_cost;
				}
				match_distance = (i * delete_cost) + _tmp24_;
				_tmp25_ = table;
				_tmp25__length1 = table_length1;
				_tmp25__length2 = table_length2;
				_tmp25_[(i * _tmp25__length2) + 0] = MIN (MIN (delete_distance, insert_distance), match_distance);
			}
		}
	}
	{
		gint j = 0;
		j = 1;
		{
			gboolean _tmp26_ = FALSE;
			_tmp26_ = TRUE;
			while (TRUE) {
				gint _tmp28_;
				gint _tmp29_;
				gint* _tmp30_;
				gint _tmp30__length1;
				gint _tmp30__length2;
				gint _tmp31_;
				gint _tmp32_ = 0;
				gint* _tmp33_;
				gint _tmp33__length1;
				gint _tmp33__length2;
				if (!_tmp26_) {
					gint _tmp27_;
					_tmp27_ = j;
					j = _tmp27_ + 1;
				}
				_tmp26_ = FALSE;
				_tmp28_ = strlen (target);
				_tmp29_ = _tmp28_;
				if (!(j < _tmp29_)) {
					break;
				}
				delete_distance = ((j + 1) * insert_cost) + delete_cost;
				_tmp30_ = table;
				_tmp30__length1 = table_length1;
				_tmp30__length2 = table_length2;
				_tmp31_ = _tmp30_[(0 * _tmp30__length2) + (j - 1)];
				insert_distance = _tmp31_ + insert_cost;
				if (string_get_char (source, (glong) 0) == string_get_char (target, (glong) j)) {
					_tmp32_ = 0;
				} else {
					_tmp32_ = replace_cost;
				}
				match_distance = (j * insert_cost) + _tmp32_;
				_tmp33_ = table;
				_tmp33__length1 = table_length1;
				_tmp33__length2 = table_length2;
				_tmp33_[(0 * _tmp33__length2) + j] = MIN (MIN (delete_distance, insert_distance), match_distance);
			}
		}
	}
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp34_ = FALSE;
			_tmp34_ = TRUE;
			while (TRUE) {
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_ = 0;
				GeeHashMap* _tmp60_;
				if (!_tmp34_) {
					gint _tmp35_;
					_tmp35_ = i;
					i = _tmp35_ + 1;
				}
				_tmp34_ = FALSE;
				_tmp36_ = strlen (source);
				_tmp37_ = _tmp36_;
				if (!(i < _tmp37_)) {
					break;
				}
				if (string_get_char (source, (glong) i) == string_get_char (target, (glong) 0)) {
					_tmp38_ = 0;
				} else {
					_tmp38_ = -1;
				}
				maxSourceLetterMatchIndex = _tmp38_;
				{
					gint j = 0;
					j = 1;
					{
						gboolean _tmp39_ = FALSE;
						_tmp39_ = TRUE;
						while (TRUE) {
							gint _tmp41_;
							gint _tmp42_;
							GeeHashMap* _tmp43_;
							gpointer _tmp44_;
							gint _tmp45_;
							gint* _tmp46_;
							gint* _tmp47_;
							gint _tmp47__length1;
							gint _tmp47__length2;
							gint _tmp48_;
							gint* _tmp49_;
							gint _tmp49__length1;
							gint _tmp49__length2;
							gint _tmp50_;
							gint* _tmp51_;
							gint _tmp51__length1;
							gint _tmp51__length2;
							gint _tmp52_;
							gboolean _tmp53_ = FALSE;
							gint* _tmp54_;
							gint* _tmp59_;
							gint _tmp59__length1;
							gint _tmp59__length2;
							if (!_tmp39_) {
								gint _tmp40_;
								_tmp40_ = j;
								j = _tmp40_ + 1;
							}
							_tmp39_ = FALSE;
							_tmp41_ = strlen (target);
							_tmp42_ = _tmp41_;
							if (!(j < _tmp42_)) {
								break;
							}
							_tmp43_ = sourceIndexByCharacter;
							_tmp44_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp43_, (gpointer) ((gintptr) string_get_char (target, (glong) j)));
							_tmp45_ = (gint) ((gintptr) _tmp44_);
							_tmp46_ = __int_dup0 (&_tmp45_);
							_g_free0 (candidateSwapIndex);
							candidateSwapIndex = _tmp46_;
							jSwap = maxSourceLetterMatchIndex;
							_tmp47_ = table;
							_tmp47__length1 = table_length1;
							_tmp47__length2 = table_length2;
							_tmp48_ = _tmp47_[((i - 1) * _tmp47__length2) + j];
							delete_distance = _tmp48_ + delete_cost;
							_tmp49_ = table;
							_tmp49__length1 = table_length1;
							_tmp49__length2 = table_length2;
							_tmp50_ = _tmp49_[(i * _tmp49__length2) + (j - 1)];
							insert_distance = _tmp50_ + insert_cost;
							_tmp51_ = table;
							_tmp51__length1 = table_length1;
							_tmp51__length2 = table_length2;
							_tmp52_ = _tmp51_[((i - 1) * _tmp51__length2) + (j - 1)];
							match_distance = _tmp52_;
							if (string_get_char (source, (glong) i) != string_get_char (target, (glong) j)) {
								match_distance += replace_cost;
							} else {
								maxSourceLetterMatchIndex = j;
							}
							_tmp54_ = candidateSwapIndex;
							if (_tmp54_ != NULL) {
								_tmp53_ = jSwap != -1;
							} else {
								_tmp53_ = FALSE;
							}
							if (_tmp53_) {
								gint iSwap = 0;
								gint* _tmp55_;
								gint preswap_cost = 0;
								gboolean _tmp56_ = FALSE;
								_tmp55_ = candidateSwapIndex;
								iSwap = *_tmp55_;
								if (iSwap == 0) {
									_tmp56_ = jSwap == 0;
								} else {
									_tmp56_ = FALSE;
								}
								if (_tmp56_) {
									preswap_cost = 0;
								} else {
									gint* _tmp57_;
									gint _tmp57__length1;
									gint _tmp57__length2;
									gint _tmp58_;
									_tmp57_ = table;
									_tmp57__length1 = table_length1;
									_tmp57__length2 = table_length2;
									_tmp58_ = _tmp57_[(MAX (0, iSwap - 1) * _tmp57__length2) + MAX (0, jSwap - 1)];
									preswap_cost = _tmp58_;
								}
								swap_distance = ((preswap_cost + (((i - iSwap) - 1) * delete_cost)) + (((j - jSwap) - 1) * insert_cost)) + swap_cost;
							} else {
								swap_distance = G_MAXINT;
							}
							_tmp59_ = table;
							_tmp59__length1 = table_length1;
							_tmp59__length2 = table_length2;
							_tmp59_[(i * _tmp59__length2) + j] = MIN (MIN (MIN (delete_distance, insert_distance), match_distance), swap_distance);
						}
					}
				}
				_tmp60_ = sourceIndexByCharacter;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp60_, (gpointer) ((gintptr) string_get_char (source, (glong) i)), (gpointer) ((gintptr) i));
			}
		}
	}
	_tmp61_ = table;
	_tmp61__length1 = table_length1;
	_tmp61__length2 = table_length2;
	_tmp62_ = strlen (source);
	_tmp63_ = _tmp62_;
	_tmp64_ = strlen (target);
	_tmp65_ = _tmp64_;
	_tmp66_ = _tmp61_[((_tmp63_ - 1) * _tmp61__length2) + (_tmp65_ - 1)];
	result = _tmp66_;
	_g_object_unref0 (sourceIndexByCharacter);
	table = (g_free (table), NULL);
	_g_free0 (candidateSwapIndex);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

